(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/common/http'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ngx-httpclient-busy', ['exports', '@angular/common', '@angular/core', '@angular/common/http', 'rxjs', 'rxjs/operators'], factory) :
    (factory((global['ngx-httpclient-busy'] = {}),global.ng.common,global.ng.core,global.ng.common.http,global.rxjs,global.rxjs.operators));
}(this, (function (exports,common,i0,http,rxjs,operators) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CounterService = /** @class */ (function () {
        function CounterService() {
            var _this = this;
            this._connectionCounter = 0;
            this._observable = rxjs.Observable.create(( /**
             * @param {?} subscriber
             * @return {?}
             */function (subscriber) {
                _this._subscriber = subscriber;
            })).pipe(operators.share());
        }
        Object.defineProperty(CounterService.prototype, "observable", {
            get: /**
             * @return {?}
             */ function () {
                return this._observable;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        CounterService.prototype.increment = /**
         * @return {?}
         */
            function () {
                this._connectionCounter += 1;
                this._next();
            };
        /**
         * @return {?}
         */
        CounterService.prototype.decrement = /**
         * @return {?}
         */
            function () {
                this._connectionCounter -= 1;
                this._next();
            };
        /**
         * @private
         * @return {?}
         */
        CounterService.prototype._next = /**
         * @private
         * @return {?}
         */
            function () {
                if (this._subscriber) {
                    this._subscriber.next(this._connectionCounter);
                }
            };
        CounterService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        CounterService.ctorParameters = function () { return []; };
        /** @nocollapse */ CounterService.ngInjectableDef = i0.defineInjectable({ factory: function CounterService_Factory() { return new CounterService(); }, token: CounterService, providedIn: "root" });
        return CounterService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HttpClientBusyDirective = /** @class */ (function () {
        function HttpClientBusyDirective(el, renderer, counter) {
            this.el = el;
            this.renderer = renderer;
            this.counter = counter;
            this.httpClientBusyConfig = {};
        }
        /**
         * @private
         * @param {?} count
         * @return {?}
         */
        HttpClientBusyDirective.prototype._updateStatus = /**
         * @private
         * @param {?} count
         * @return {?}
         */
            function (count) {
                /** @type {?} */
                var busy = count > 0;
                /** @type {?} */
                var hasIdle = this.el.nativeElement.classList.contains(this.httpClientBusyConfig.idle);
                /** @type {?} */
                var hasBusy = this.el.nativeElement.classList.contains(this.httpClientBusyConfig.busy);
                if (busy) {
                    if (this.httpClientBusyConfig.idle && hasIdle) {
                        this.renderer.removeClass(this.el.nativeElement, this.httpClientBusyConfig.idle);
                    }
                    if (this.httpClientBusyConfig.busy && !hasBusy) {
                        this.renderer.addClass(this.el.nativeElement, this.httpClientBusyConfig.busy);
                    }
                }
                else {
                    if (this.httpClientBusyConfig.busy && hasBusy) {
                        this.renderer.removeClass(this.el.nativeElement, this.httpClientBusyConfig.busy);
                    }
                    if (this.httpClientBusyConfig.idle && !hasIdle) {
                        this.renderer.addClass(this.el.nativeElement, this.httpClientBusyConfig.idle);
                    }
                }
            };
        /**
         * @return {?}
         */
        HttpClientBusyDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.httpClientBusyConfig.idle = this.httpClientBusy.idle || 'fade';
                this.httpClientBusyConfig.busy = this.httpClientBusy.busy || '';
                this._updateStatus(0);
                this.autoUnsubscribe = this.counter.observable.subscribe(( /**
                 * @param {?} next
                 * @return {?}
                 */function (next) { return _this._updateStatus(next); }));
            };
        /**
         * @return {?}
         */
        HttpClientBusyDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.autoUnsubscribe.unsubscribe();
            };
        HttpClientBusyDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[httpClientBusy]'
                    },] }
        ];
        /** @nocollapse */
        HttpClientBusyDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: i0.Renderer2 },
                { type: CounterService }
            ];
        };
        HttpClientBusyDirective.propDecorators = {
            httpClientBusy: [{ type: i0.Input }]
        };
        return HttpClientBusyDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HttpClientBusyInterceptor = /** @class */ (function () {
        function HttpClientBusyInterceptor(counter) {
            this.counter = counter;
        }
        /**
         * @param {?} req
         * @param {?} next
         * @return {?}
         */
        HttpClientBusyInterceptor.prototype.intercept = /**
         * @param {?} req
         * @param {?} next
         * @return {?}
         */
            function (req, next) {
                var _this = this;
                this.counter.increment();
                return next.handle(req).pipe(operators.tap(( /**
                 * @param {?} evt
                 * @return {?}
                 */function (evt) {
                    if (evt instanceof http.HttpResponse) {
                        _this.counter.decrement();
                    }
                })), operators.catchError(( /**
                 * @param {?} err
                 * @return {?}
                 */function (err) {
                    if (err instanceof http.HttpErrorResponse) {
                        _this.counter.decrement();
                    }
                    return rxjs.throwError(err);
                })));
            };
        HttpClientBusyInterceptor.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        HttpClientBusyInterceptor.ctorParameters = function () {
            return [
                { type: CounterService }
            ];
        };
        /** @nocollapse */ HttpClientBusyInterceptor.ngInjectableDef = i0.defineInjectable({ factory: function HttpClientBusyInterceptor_Factory() { return new HttpClientBusyInterceptor(i0.inject(CounterService)); }, token: HttpClientBusyInterceptor, providedIn: "root" });
        return HttpClientBusyInterceptor;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HttpClientBusyModule = /** @class */ (function () {
        function HttpClientBusyModule() {
        }
        /**
         * @return {?}
         */
        HttpClientBusyModule.forRoot = /**
         * @return {?}
         */
            function () {
                return {
                    ngModule: HttpClientBusyModule
                };
            };
        HttpClientBusyModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [common.CommonModule, http.HttpClientModule],
                        declarations: [HttpClientBusyDirective],
                        exports: [HttpClientBusyDirective],
                        providers: [{ provide: http.HTTP_INTERCEPTORS, useClass: HttpClientBusyInterceptor, multi: true }]
                    },] }
        ];
        return HttpClientBusyModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.CounterService = CounterService;
    exports.HttpClientBusyDirective = HttpClientBusyDirective;
    exports.HttpClientBusyModule = HttpClientBusyModule;
    exports.ɵa = HttpClientBusyInterceptor;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-httpclient-busy.umd.js.map